#ugly hack
%define _noVersionedDependencies 1

#php 4.3.2 doesn't allow to use openssl shared
%define _openssl_shared 0

Summary: The PHP4 HTML-embedded scripting language for use with Apache.
Name: mod_php4
Version: 4.3.10
Release: 0.1tr
Group: Network/Services
Source0: http://www.php.net/distributions/php-%{version}.tar.bz2
Source1: php.ini
Source2: php-httpd.conf
License: GPL
BuildRoot: /var/tmp/%{name}-root
Requires: webserver, gmp, openssl, bzip2, zlib, rpm >= 3.0.6
Obsoletes: mod_php3
BuildRequires: postgresql-devel, mysql-devel, uw-imap-devel, openldap-devel
BuildRequires: apache-devel >= 2, zlib-devel, gmp-devel, flex, bzip2-devel
BuildRequires: cyrus-imapd-devel, libpng12-devel, libjpeg-devel
BuildRequires: cyrus-sasl-devel, readline-devel
BuildRequires: rpm-build >= 4.0.4-22tr
Provides: php = %{version}
%if !%{_openssl_shared}
Obsoletes: mod_php4-openssl
%endif

%description
PHP is an HTML-embedded scripting language.  PHP attempts to make it
easy for developers to write dynamically generated web pages.  PHP
also offers built-in database integration for several commercial
and non-commercial database management systems, so writing a
database-enabled web page with PHP is fairly simple.  The most
common use of PHP coding is probably as a replacement for CGI
scripts.  The mod_php module enables the Apache web server to
understand and process the embedded PHP language in web pages.

%package cli 
Summary: CLI/PHP4 support
Group: Network/Services
Requires: mod_php4
%description cli 
This package contains a standalone PHP binary. 

The CLI (command line interface) SAPI has been introduced
with a goal of making PHP better at supporting the creation of 
stand alone applications.

%if %{_openssl_shared}
%package openssl 
Summary: OpenSSL/PHP4 support
Group: Network/Services
Requires: mod_php4
%description openssl 
OpenSSL support module for PHP4

Uncomment "extension=openssl.so" in order to activate this module
%endif

%package exif
Summary: Exif/PHP4 support
Group: Network/Services
Requires: mod_php4
%description exif 
EXIF support module for PHP4

Uncomment "extension=exif.so" in order to activate this module

%package gd
Summary: GD/PHP4 support
Group: Network/Services
Requires: mod_php4
%description gd 
GD support module for PHP4

Uncomment "extension=gd.so" in order to activate this module

%package imap
Summary: IMAP/PHP4 support
Group: Network/Services
BuildRequires: uw-imap-devel openssl-devel
Requires: openssl mod_php4
%description imap
IMAP support module for PHP4

Uncomment "extension=imap.so" in order to activate this module

%package ldap
Summary: LDAP/PHP4 support
Group: Network/Services
Requires: openldap mod_php4
BuildRequires: openldap-devel mod_php4
%description ldap
LDAP support module for PHP4

Uncomment "extension=ldap.so" in order to activate this module

%package mysql
Summary: MySQL/PHP4 support
Group: Network/Services
Requires: mysql-libs zlib-devel mod_php4
%description mysql
MySQL support module for PHP4

Uncomment "extension=mysql.so" in order to activate this module

%package pgsql
Summary: PostgreSQL/PHP4 support
Group: Network/Services
Requires: postgresql-libs mod_php4
%description pgsql
PostgreSQL support module for PHP4

Uncomment "extension=pgsql.so" in order to activate this module

%package devel
Summary: PHP C/C++ development
Group: Libraries/Development

%description devel
PHP 4 C/C++ development environment
  
%package test
Summary: PHP C/C++ development
Group: Libraries/Development
Requires: %{name}

%description test
PHP 4 test suite.
  
%package domxml 
Summary: OpenSSL/PHP4 support
Group: Network/Services
BuildRequires: libxml2-devel mod_php4
Requires: libxml2 mod_php4

%description domxml 
The php-domxml package is a dynamic shared object (DSO) that adds
DOMXML support to PHP. PHP is an HTML-embedded scripting language.
If you need DOMXML support for PHP applications, you will need to
install this package in addition to the php package.

Uncomment "extension=domxml.so" in order to activate this module

%prep
%setup -q -n php-%{version}

%build
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr \
	--with-apxs2=/usr/sbin/apxs \
	--with-config-file-path=/etc/httpd \
	--with-regex=php \
	--with-exec-dir=/usr/bin \
	--enable-safe-mode \
	--enable-dba \
        --enable-bcmath \
        --enable-debugger \
        --enable-magic-quotes \
        --enable-track-vars \
	--enable-memory-limit \
	--enable-ftp \
	--enable-exif=shared,/usr \
	--disable-debug \
	--disable-rpath \
	--with-bz2 \
	--with-cyrus \
	--with-pear \
	--with-readline \
	--with-gmp \
	--with-zlib=/usr \
	--with-imap-ssl \
	--with-gd=shared \
	--with-jpeg-dir=/usr \
	--with-png-dir=/usr \
	--with-imap=shared,/usr \
	--with-ldap=shared,/usr \
	--with-mysql=shared,/usr \
	--with-pgsql=shared,/usr \
%if %{_openssl_shared}
	--with-openssl=shared,/usr \
%else
	--with-openssl=/usr \
%endif
	--with-dom=shared,/usr \
        --with-gettext

make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/lib/apache
mkdir -p $RPM_BUILD_ROOT/etc/httpd
mkdir -p $RPM_BUILD_ROOT/usr/share/php4/
mkdir -p $RPM_BUILD_ROOT/usr/bin
install -s -m 755 .libs/libphp4.so $RPM_BUILD_ROOT/usr/lib/apache
install -s -m 755 sapi/cli/php $RPM_BUILD_ROOT/usr/bin

#ugly hack, apxs pretends on changing the httpd.conf, so
#we give it a minimalistic one :)
mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf
cat <<EOF >$RPM_BUILD_ROOT/etc/httpd/conf/httpd.conf

LoadModule
EOF

make install INSTALL_ROOT=$RPM_BUILD_ROOT

# now we don't need our fake httpd.conf anymore
rm -rf $RPM_BUILD_ROOT/etc/httpd/conf

strip modules/*.so
cp modules/*.so $RPM_BUILD_ROOT/usr/share/php4/

mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf.d
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT/etc/httpd/php.ini
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT/etc/httpd/conf.d/httpd-mod_php4.conf

# Wonder why these are located here
#rm -rf $RPM_BUILD_ROOT/usr/lib/php/extensions
#rm -rf $RPM_BUILD_ROOT/usr/lib/php/build
#rm -rf $RPM_BUILD_ROOT/usr/lib/php/.??*

# Not to mention why this ended up here
mkdir -p -m 755 $RPM_BUILD_ROOT/usr/share/doc/%{name}-%{version}
mv $RPM_BUILD_ROOT/usr/lib/php/doc/* $RPM_BUILD_ROOT/usr/share/doc/%{name}-%{version}/


%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/usr/lib/apache/libphp4.so
%config(noreplace) /etc/httpd/php.ini
%config(noreplace) /etc/httpd/conf.d/httpd-mod_php4.conf
%doc CODING_STANDARDS CREDITS EXTENSIONS INSTALL LICENSE NEWS
%doc README.EXTENSIONS README.EXT_SKEL README.PARAMETER_PARSING_API
%doc README.SELF-CONTAINED-EXTENSIONS README.STREAMS README.SUBMITTING_PATCH
%doc README.TESTING README.UNIX-BUILD-SYSTEM TODO TODO.BUILDv5
/usr/bin/pear
/usr/bin/php-config
/usr/bin/phpextdist
/usr/bin/phpize
%dir /usr/lib/php
/usr/lib/php/*.php
/usr/lib/php/Archive
/usr/lib/php/Console
/usr/lib/php/DB
/usr/lib/php/Mail
/usr/lib/php/Net
/usr/lib/php/OS
/usr/lib/php/PEAR
/usr/lib/php/XML
/usr/lib/php/build
/usr/lib/php/data

%files gd
%defattr(-,root,root)
/usr/share/php4/gd.so

%files cli
%defattr(-,root,root)
/usr/bin/php

%files exif 
%defattr(-,root,root)
/usr/share/php4/exif.so

%if %{_openssl_shared}
%files openssl
%defattr(-,root,root)
/usr/share/php4/openssl.so
%endif

%files imap
%defattr(-,root,root)
/usr/share/php4/imap.so

%files ldap
%defattr(-,root,root)
/usr/share/php4/ldap.so

%files mysql
%defattr(-,root,root)
/usr/share/php4/mysql.so

%files pgsql
%defattr(-,root,root)
/usr/share/php4/pgsql.so

%files devel
%defattr(-,root,root)
/usr/include/php

%files test
%defattr(-,root,root)
/usr/lib/php/test

%files domxml
%defattr(-,root,root)
/usr/share/php4/domxml.so

%changelog
* Fri Dec 17 2004 Erlend Midttun <erlendbm at trustix dot org> 4.3.10-0.1tr
- New upstream.

* Thu Sep 30 2004 Erlend Midttun <erlendbm at trustix dot org> 4.3.9-0.1tr
- New upstream.

* Thu Jul 22 2004 Oystein Viggen <oysteivi at trustix dot com> 2.3.8-1tr
- New upstream.

* Mon Feb 23 2004 Erlend Midttun <erlendbm at trustix dot org> 4.3.4-3tr
- Turns out we need to fix the error in rpm rather than nuking
  /usr/lib/php/build as it breaks phpize.

* Thu Feb  5 2004 Erlend Midttun <erlendbm at trustix dot org> 4.3.4-2tr
- Take II, now without /usr/lib/php/build.

* Thu Feb  5 2004 Erlend Midttun <erlendbm at trustix dot org> 4.3.4-1tr
- New upstream.

* Thu Oct 30 2003 Chr. Toldnes <christht at trustix dot org> 4.3.2-11tr
- quick retag to fix 64bit mess.

* Mon Jun 23 2003 Erlend Midttun <erlendbm at trustix dot com> 4.3.2-8tr
- Added %defattr

* Sat Jun 21 2003 Gerald Dachs <gda at trustix dot org> 4.3.2-7gd
- Added --with-gettext
 
* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 4.3.2-6tr
- Big rebuild

* Wed Jun 11 2003 Gerald Dachs <gda at trustix dot org> 4.3.2-5gd
- buildrequries cyrus-sasl-devel, readline-devel

* Wed Jun 11 2003 Gerald Dachs <gda at trustix dot org> 4.3.2-4gd
- use --with-regex=php now, removed patch0

* Sat Jun  7 2003 Erlend Midttun <erlendbm at trustix dot com> 4.3.2-3em
- Fix file conflict on /usr/bin/php.

* Sun Jun  1 2003 Erlend Midttun <erlendbm at trustix dot com> 4.3.2-2em
- Removed libapr-devel

* Sat Jun  1 2003 Gerald Dachs <gda at trustix dot org> 4.3.2-1gd
- New upstream version.
- openssl linked static, because of bug in php
- hack for pleasing apxs with a fake httpd.conf
- made patch to allow to use --with-regex=system

* Wed May 28 2003 Gerald Dachs <gda at trustix dot org> 4.3.1-8gd
- Added package domxml

* Fri May 23 2003 Tor Hveem <torh at trustix dot org> 4.3.1-7th
- Missing BuildReq readline-devel, libpng-devel, libjpeg-devel, mysql-devel
- Added --with-cyrus
- Added package gd

* Thu May 15 2003 Erlend Midttun <erlendbm at trustix dot com> 4.3.1-6em
- Moved docs

* Wed Apr 30 2003 Erlend Midttun <erlendbm at trustix dot com> 4.3.1-5em
- Major cleanup.

* Wed Apr 30 2003 Erlend Midttun <erlendbm at trustix dot com> 4.3.1-4em
- mod_php4-pgsql requires postgresql-libs and not postgresql.

* Mon Apr 28 2003 Erlend Midttun <erlendbm at trustix dot com> 4.3.1-3em
- Rebuild against new mysql.

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 4.3.1-2em
- Rebuilt against glibc 2.3.2.

* Thu Mar 20 2003 Erlend Midttun <erlendbm at trustix dot com> 4.3.1-1em
- New upstream version.

* Fri Feb 28 2003 Erlend Midttun <erlendbm at trustix dot com> 4.3.0-6em
- Fixed entension dir.

* Wed Feb 19 2003 Erlend Midttun <erlendbm at trustix dot com> 4.3.0-5em
- Added conf file.

* Sat Jan 18 2003 Gerald Dachs <gda at trustix dot org> 4.3.0-4gd
- rebuilt against openssl 0.9.7

* Sat Jan 11 2003 Tor Hveem <torh at trustix dot org> 4.3.0-3th
- added packages: openssl, cli, exif

* Fri Jan  3 2003 Erlend Midttun <erlendbm at trustix dot com> 4.3.0-2em
- Changed Req: imap to BuildReq: uw-imap-devel on -imap package
- New and improved php.ini file.  Slightly modified php.ini-recommended.

* Sat Dec 28 2002 Tor Hveem <torh at trustix dot org> 4.3.0-1th
- New upstream version: 4.3.0
- Removed tsrm patch
- Added new build requirements bzip2-devel, libapr-devel
- Readded imap module

* Thu Sep 26 2002 Erlend Midttun <erlendbm at trustix dot com> 4.2.3-2em
- Added buildreq flex.

* Wed Sep 11 2002 Erlend Midttun <erlendbm at trustix dot com> 4.2.3-1em
- New PHP.
- Now required Apache 2.

* Mon Mar 25 2002 Christian H. Toldnes <christht at trustix dot com>
- The old rfc1867.c didn't fix it. Applied a new patch.

* Thu Feb 28 2002 Christian H. Toldnes <christht at trustix dot com>
- Applied securitypatch. (rfc1867.c)

* Wed Sep 26 2001 Erlend Midttun <erlendbm at trustix dot com>
- Seems the previous mailsec patch was broken, trying again.

* Thu Jul 26 2001 Erlend Midttun <erlendbm at trustix dot com>
- Fixed a few dependencies.

* Thu Jul 19 2001 Oystein Viggen <oysteivi at trustix dot com>
- Add a fix from cvs to stop mail() from breaking safe mode.

* Mon Jul 16 2001 Oystein Viggen <oysteivi at trustix dot com>
- 4.0.6 didn't fix memlimit.  Added patch from the php team.

* Mon Jul  9 2001 Oystein Viggen <oysteivi at trustix dot com>
- Because of build problems, imap is no longer built as a module.

* Tue Jul  3 2001 Oystein Viggen <oysteivi at trustix dot com>
- define _noVersionedDependencies

* Mon Jul  2 2001 Oystein Viggen <oysteivi at trustix dot com>
- New upstream version: 4.0.6
- This new version fixes a bug with --enable-memory-limit

* Mon Jun 11 2001 Oystein Viggen <oysteivi at trustix dot com>
- New upstream version: 4.0.5

* Mon Mar 19 2001 Alexander Reelsen <ar at trustix dot com>
- Picked up 4.0.4pl1
- Created dynamic modules (and own packages) for imap, ldap, mysql and pgsql

* Wed Oct 18 2000 Per Ivar Paulsen <perp at trustix dot com>
- Update to 3.0.17. Removed syslog patch

* Wed May 3 2000 Per Ivar Paulsen <perp at trustix dot com>
- Update to php 3.0.16

* Sat Feb 26 2000 Lars Gaarden <larsg at trustix dot com>
- Picked up php 3.0.15

* Fri Feb 25 2000 Lars Gaarden <larsg at trustix dot com>
- Added Provides: php

* Tue Jan 25 2000 Per Ivar Paulsen <perp at trustix dot com>
- picked up php 3.0.14.
- Initial release for the Trustix Secure Linux distribution.
- Added noreplace.
- Moved man and info pages to /usr/share adhering to FHS
- TODO: add better default configuration

* Wed Jan 6 2000 Per Ivar Paulsen <perp@paulsen.org>
- picked up php 3.0.13. And updated manual

* Fri Apr 16 1999 Preston Brown <pbrown@redhat.com>
- pick up php3.ini

* Wed Mar 24 1999 Preston Brown <pbrown@redhat.com>
- build against apache 1.3.6

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 2)

* Mon Mar 08 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 3.0.7.

* Wed Feb 24 1999 Preston Brown <pbrown@redhat.com>
- Injected new description and group.

* Sun Feb 07 1999 Preston Brown <pbrown@redhat.com>
- upgrade to php 3.0.6, built against apache 1.3.4

* Mon Oct 12 1998 Cristian Gafton <gafton@redhat.com>
- rebuild for apache 1.3.3

* Thu Oct 08 1998 Preston Brown <pbrown@redhat.com>
- updated to 3.0.5, fixes nasty bugs in 3.0.4.

* Sun Sep 27 1998 Cristian Gafton <gafton@redhat.com>
- updated to 3.0.4 and recompiled for apache 1.3.2

* Thu Sep 03 1998 Preston Brown <pbrown@redhat.com>
- improvements; builds with apache-devel package installed.

* Tue Sep 01 1998 Preston Brown <pbrown@redhat.com>
- Made initial cut for PHP3.
